*** applications/aufs/afposfi.c.orig	Thu May 19 12:19:56 1988
--- applications/aufs/afposfi.c	Thu Jan 26 18:22:52 1989
***************
*** 63,68
  private void fc_flush_start();
  private void fc_flush_end();
  private FileInfo *os_getfi();
  
  #define FICacheSize 128
  /* Each cache entry has a lifetime that it goes through before it must */

--- 63,69 -----
  private void fc_flush_start();
  private void fc_flush_end();
  private FileInfo *os_getfi();
+ private fc_readent();
  
  #define FICacheSize 128
  /* Each cache entry has a lifetime that it goes through before it must */
***************
*** 104,109
  
    OSfname(path, pdir, "", F_FNDR); /* get directory */
    if (stat(path, &stb) < 0) {
      fcf_val_dir = NILDIR;
      fcf_val_time = 0;
      return;			/* nothing else we can do */

--- 105,118 -----
  
    OSfname(path, pdir, "", F_FNDR); /* get directory */
    if (stat(path, &stb) < 0) {
+ #ifdef NOCASEMATCH
+     noCaseFind(path);
+     if (stat(path, &stb) < 0) {
+       fcf_val_dir = NILDIR;
+       fcf_val_time = 0;
+       return;			/* nothing else we can do */
+     }
+ #else NOCASEMATCH
      fcf_val_dir = NILDIR;
      fcf_val_time = 0;
      return;			/* nothing else we can do */
***************
*** 107,112
      fcf_val_dir = NILDIR;
      fcf_val_time = 0;
      return;			/* nothing else we can do */
    }
    fcf_val_dir = pdir;
    fcf_val_time = stb.st_mtime;	/* remember */

--- 116,122 -----
      fcf_val_dir = NILDIR;
      fcf_val_time = 0;
      return;			/* nothing else we can do */
+ #endif NOCASEMATCH
    }
    fcf_val_dir = pdir;
    fcf_val_time = stb.st_mtime;	/* remember */
***************
*** 142,147
      if (fcf_val_dir == fe->fe_pdir &&
  	(fcf_val_time > fe->fe_mtime) &&
  	(fcf_val_time > fe->fe_vtime)) {
        if (stat(path, &stb) < 0)
  	return;				/* nothing else we can do */
        if (stb.st_mtime != fe->fe_mtime)	/* reload entry */

--- 152,164 -----
      if (fcf_val_dir == fe->fe_pdir &&
  	(fcf_val_time > fe->fe_mtime) &&
  	(fcf_val_time > fe->fe_vtime)) {
+ #ifdef NOCASEMATCH
+       if (stat(path, &stb) < 0) {
+ 	noCaseFind(path);
+         if (stat(path, &stb) < 0)
+ 	  return;			/* nothing else we can do */
+       }
+ #else NOCASEMATCH
        if (stat(path, &stb) < 0)
  	return;				/* nothing else we can do */
  #endif NOCASEMATCH
***************
*** 144,149
  	(fcf_val_time > fe->fe_vtime)) {
        if (stat(path, &stb) < 0)
  	return;				/* nothing else we can do */
        if (stb.st_mtime != fe->fe_mtime)	/* reload entry */
  	fe->fe_okay = FALSE;		/* make entry as bad */
      }

--- 161,167 -----
  #else NOCASEMATCH
        if (stat(path, &stb) < 0)
  	return;				/* nothing else we can do */
+ #endif NOCASEMATCH
        if (stb.st_mtime != fe->fe_mtime)	/* reload entry */
  	fe->fe_okay = FALSE;		/* make entry as bad */
      }
***************
*** 167,172
      if ((fe->fe_pdir->flags & DID_FINDERINFO) == 0) /* always okay */
        return(fe->fe_okay);
      OSfname(path, fe->fe_pdir, fe->fe_fnam, F_FNDR);
      if (stat(path, &stb) < 0)
        return(fe->fe_okay);		/* nothing else we can do */
      if (stb.st_mtime != fe->fe_mtime)	/* reload entry */

--- 185,197 -----
      if ((fe->fe_pdir->flags & DID_FINDERINFO) == 0) /* always okay */
        return(fe->fe_okay);
      OSfname(path, fe->fe_pdir, fe->fe_fnam, F_FNDR);
+ #ifdef NOCASEMATCH
+     if (stat(path, &stb) < 0) {
+       noCaseFind(path);
+       if (stat(path, &stb) < 0)
+         return(fe->fe_okay);		/* nothing else we can do */
+     }
+ #else NOCASEMATCH
      if (stat(path, &stb) < 0)
        return(fe->fe_okay);		/* nothing else we can do */
  #endif NOCASEMATCH
***************
*** 169,174
      OSfname(path, fe->fe_pdir, fe->fe_fnam, F_FNDR);
      if (stat(path, &stb) < 0)
        return(fe->fe_okay);		/* nothing else we can do */
      if (stb.st_mtime != fe->fe_mtime)	/* reload entry */
        return(FALSE);			/* bad entry */
    }

--- 194,200 -----
  #else NOCASEMATCH
      if (stat(path, &stb) < 0)
        return(fe->fe_okay);		/* nothing else we can do */
+ #endif NOCASEMATCH
      if (stb.st_mtime != fe->fe_mtime)	/* reload entry */
        return(FALSE);			/* bad entry */
    }
***************
*** 253,258
        printf("fc_readent: reading %s\n",path);
  
      fd = open(path,O_RDONLY);
      if (fd >= 0) {
        OSLockFileforRead(fd);
        err = fstat(fd, &stb);

--- 279,290 -----
        printf("fc_readent: reading %s\n",path);
  
      fd = open(path,O_RDONLY);
+ #ifdef NOCASEMATCH
+     if(fd < 0) {
+       noCaseFind(path);
+       fd = open(path,O_RDONLY);
+     }
+ #endif NOCASEMATCH
      if (fd >= 0) {
        OSLockFileforRead(fd);
        err = fstat(fd, &stb);
***************
*** 309,314
  
    /* convert name to internal name */
    OSfname(path,fe->fe_pdir,fe->fe_fnam,F_DATA); /* create plain name */
    if (stat(path,&stb) != 0)		/* check if it exists */
      return(aeObjectNotFound);		/* no... */
    if (S_ISDIR(stb.st_mode)) {

--- 341,353 -----
  
    /* convert name to internal name */
    OSfname(path,fe->fe_pdir,fe->fe_fnam,F_DATA); /* create plain name */
+ #ifdef NOCASEMATCH
+   if (stat(path,&stb) != 0) {		/* check if it exists */
+     noCaseFind(path);
+     if (stat(path,&stb) != 0)		/* check if it exists */
+       return(aeObjectNotFound);		/* no... */
+   }
+ #else NOCASEMATCH
    if (stat(path,&stb) != 0)		/* check if it exists */
      return(aeObjectNotFound);		/* no... */
  #endif NOCASEMATCH
***************
*** 311,316
    OSfname(path,fe->fe_pdir,fe->fe_fnam,F_DATA); /* create plain name */
    if (stat(path,&stb) != 0)		/* check if it exists */
      return(aeObjectNotFound);		/* no... */
    if (S_ISDIR(stb.st_mode)) {
      fi->fi_comln = 0;
    } else {

--- 350,356 -----
  #else NOCASEMATCH
    if (stat(path,&stb) != 0)		/* check if it exists */
      return(aeObjectNotFound);		/* no... */
+ #endif NOCASEMATCH
    if (S_ISDIR(stb.st_mode)) {
      fi->fi_comln = 0;
    } else {
***************
*** 352,358
      printf("WriteFA: writing %s\n",path);
  
    needu++;
!   if ((fd = open(path,O_WRONLY)) < 0) {		/* open for write */
      if (errno != ENOENT) {
        printf("WriteFA: error openning %s errno=%d\n",path,errno);
        return;

--- 392,405 -----
      printf("WriteFA: writing %s\n",path);
  
    needu++;
!   fd = open(path,O_WRONLY);
! #ifdef NOCASEMATCH
!   if(fd < 0) {
!     noCaseFind(path);
!     fd = open(path,O_WRONLY);
!   }
! #endif NOCASEMATCH
!   if (fd < 0) {				/* open for write */
      if (errno != ENOENT) {
        printf("WriteFA: error openning %s errno=%d\n",path,errno);
        return;
